/*
 * A library
 * for use with C111 CAMAC driver
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include "./include/naf.h"

void c111a(int crate_fd, int cn, int ca, int cf, int *cq, int *cx, int *cdata)
{
  int naf = NAF(cn, ca, cf);
  int cb;

  lseek(crate_fd, naf, SEEK_SET);
  if (cf <= 7) 
  { 
     cb=read(crate_fd, cdata, 4);
  }
  else if (cf>=16 && cf <=23) 
  {
     cb=write(crate_fd, cdata, 4);
  }
  else
  {
     cb=ioctl(crate_fd, *cdata, 4);
  }
  *cq = Q(cb);
  *cx = X(cb);
}

/* FORTRAN interface */
void c111a_(int *crate_fd, int *cn, int *ca, int *cf, int *cq, int *cx, int *cdata)
{
  c111a(*crate_fd,*cn,*ca,*cf,cq,cx,cdata);
}

int  c111aopen(int crate)
{
  char s[12];
  int crate_fd;

  if (crate>=0 && crate<=14)
  {
    sprintf(s,"/dev/c111a%i",crate);
    crate_fd = open(s,O_RDWR);
    if (crate_fd>0) return crate_fd; else return -2;
  }
  else return -1;
}

void c111aopen_(int *crate, int *crate_fd)
{
  *crate_fd = c111aopen(*crate);
}

void c111ainit(int crate_fd)
{
  int q, x, data;
  c111a(crate_fd, 25, 1, 38, &q, &x, &data);
  c111a(crate_fd, 25, 1, 36, &q, &x, &data);
}

/* FORTRAN interface */
void c111ainit_(int *crate_fd)
{
  c111ainit(*crate_fd);
}

int  c111aclose(int crate_fd)
{
  return close(crate_fd);
}

/* FORTRAN interface */
void c111aclose_(int *crate_fd, int *ierr)
{
  *ierr = c111aclose(*crate_fd); 
}










