/*
 * A simple CAMAC shell
 * for use with C111 CAMAC driver
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include "./include/c111a.h"

void printhelp(void);
static void handler(int);

int main(int argc, char **argv)
{
  char s[1024]; /* for the input line */
  int crate_fd;
  int crate_nr;
  int n,a,f;
  int qx;
  int data;
  int tmp;
  int tmp_fd;
  int q, x;
  
  printf("CAMAC shell\n");
  printf("ARGC=\n");

  if (argc < 2) 
    for (crate_nr = 0; crate_nr <= 15; crate_nr++) {
      sprintf(s,"/dev/c111a%i",crate_nr);
      if ((crate_fd = open(s,O_RDWR)) > 0) break;
    } 
  else {
    crate_nr = atoi(argv[1]);
    printf("You requested crate n. %i\n",crate_nr);
    sprintf(s,"/dev/c111a%i",crate_nr);
    if ((crate_fd = open(s,O_RDWR)) <= 0) {
      perror(s);
      exit(1);
    }
  } 
  
  if (crate_nr > 15) {
    printf("no crate found\n");
    exit(1);
  }

  printf("c111a%i > ",crate_nr);

  while(fgets(s,sizeof(s),stdin)) {
    switch (s[0]) {
    case 'n':
      if (sscanf(s,"n=%i",&tmp) == 1)
	n = tmp;
      else
	printf("Error reading Address n\n");
      break;
    case 'a':
    if (sscanf(s,"a=%i",&tmp) == 1)
      a = tmp;
    else
      printf("Error reading Subaddress a\n");
      break;
    case 'f':
      if (sscanf(s,"f=%i",&tmp) == 1)
	f = tmp;
      else
	printf("Error reading Function f\n");
      break;
    case 'd':
      if (sscanf(s,"d=%i",&tmp) == 1)
	data = tmp;
      else
	printf("Error reading Data d\n");
      break;
    case 'c':
      if (sscanf(s,"c=%i",&tmp) == 1) {
	if (tmp == crate_nr) 
	  break;
	sprintf(s,"/dev/c111a%i",tmp);
	if ((tmp_fd = open(s,O_RDWR)) > 0) {
	  close(crate_fd);
	  crate_nr = tmp;
	  crate_fd = tmp_fd;
	}
	else 
	  perror(s);
      } 
      else
	printf("Error reading Crate number c\n");
      break;      
    case 'e':
      c111a(crate_fd,n,a,f,&q,&x,&data);
      printf("    NAF>%2i %2i %2i\n",n,a,f);
      printf("      Q> %1i\n      X> %1i\n      D> %8i \n",q,x,data);
      break;
    case 'q':
      exit(0);
    default:
      printhelp();
    } 
    printf("c111a%i > ",crate_nr);
  }

  exit(2); /* never reached */

} /* main() */

void printhelp(void)
{
  printf("Syntax:\n");
  printf("n=12 ..... set address to 12\n");
  printf("a=3 ...... set subaddress to 3\n");
  printf("f=1 ...... set function code 1\n");
  printf("c=1 ...... set CAMAC crate\n");
  printf("e ........ execute CAMAC cycle\n");
  printf("q ........ quit\n");
}













