#include "include/c111a.h"
#include "include/naf.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>   
#include <unistd.h>    
#include <stdio.h>
    
/*
 * This is an example program for use of the c111a CAMAC driver
 *
 */

#define MAXLOOP 100

int main() {
  int jq, jx, jdata, i;
  int fifo, n, iret;

  /* open crate 0 */
  int crate=c111aopen(0);

  c111ainit(crate);
  /*
   * Open FIFO 
   *
   */
  fifo = open("/dev/c111adata", O_RDONLY);
  if (fifo < 0) {
    printf("ERROR: Cannot open FIFO /dev/c111adata : %i\n", fifo);
    exit(1);
  }

  c111a(crate,0,i,100,&jq,&jx,&jdata); /* load irq handler with function 0 (read) */
  c111a(crate,0,i,109,&jq,&jx,&jdata); /* load irq handler with function 9 (clear) */

  c111a(crate,0,0,41,&jq,&jx,&jdata);   /* Enable LAM irq          */

  c111a(crate,0,0,26,&jq,&jx,&jdata);   /* enable LAM              */

  for (i=0; i<=MAXLOOP; i++) {
    /*
     * Look for data in FIFO
     *
     */
    int buf[2];
    n = read(fifo, &buf, 2*sizeof(jdata));
    printf("DATA: %i   CTRL: %i\n",buf[0],buf[1]);
  }
  c111a(crate,0,0, 9,&jq,&jx,&jdata);   /* Reset module            */
}










