#ifndef _NAF_H
#define _NAF_H 

/*
 * Functions to encode/decode NAF 24 bits word
 * 
 * bit No. : 0 1 2 3 4 5 6 7 8 9 A B C D E F
 *           --------- --------- ------- - -
 *           Station n Function  Address - S
 *
 * naf code is loaded as soon as S=1 (0x8000)
 *
 * In order to define new (non standard) CAMAC commands we define a second
 * NAF codification with a further bit for function definitions. Being this
 * codification the one seen by the user we define NAF2 the PC16 Coding:
 *
 * bit No. : 0 1 2 3 4 5 6 7 8 9 A B C D E F G
 *           --------- ----------- ------- - -
 *           Station n Function    Address - S
 */

int NAF2(int, int, int);
int NAF(int, int, int);
int N_NAF(int);
int A_NAF(int);
int F_NAF(int);
int N_NAF2(int);
int A_NAF2(int);
int F_NAF2(int);
int Q(int);
int L(int);
int X(int);

#endif /* _NAF_H */
